﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading;
using Telerik.Windows.Controls;

namespace BusyIndicatorWithBackgroundWorker
{
    public class ViewModel : ViewModelBase
    {
        private ObservableCollection<string> items;

        private BackgroundWorker BackgroundWorker = new BackgroundWorker();

        private bool isBusy;

        public ViewModel()
        {
            this.BackgroundWorker.DoWork += BackgroundWorker_DoWork;
            this.BackgroundWorker.RunWorkerCompleted += BackgroundWorker_RunWorkerCompleted;
            this.BackgroundWorker.RunWorkerAsync();
        }

        private ObservableCollection<string> GetData()
        {
            return new ObservableCollection<string>()
            {
                "Item 1",
                "Item 2",
                "Item 3",
                "Item 4",
                "Item 5"
            };
        }

        void BackgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            this.IsBusy = false;
        }

        void BackgroundWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            this.IsBusy = true;
            Thread.Sleep(3000);
            this.Items = GetData();
        }

        public bool IsBusy
        {
            get
            {
                return this.isBusy;
            }

            set
            {
                if (this.isBusy != value)
                {
                    this.isBusy = value;
                    this.OnPropertyChanged(() => this.IsBusy);
                }
            }
        }

        /// <summary>
        /// Gets or sets Items and notifies for changes
        /// </summary>
        public ObservableCollection<string> Items
        {
            get
            {
                return this.items;
            }

            set
            {
                if (this.items != value)
                {
                    this.items = value;
                    this.OnPropertyChanged(() => this.Items);
                }
            }
        }
    }
}
